use axum::{
    http,
    response::{IntoResponse, Response},
};

pub struct AppError(anyhow::Error);

impl<T: Into<anyhow::Error>> From<T> for AppError {
    fn from(err: T) -> Self {
        AppError(err.into())
    }
}

impl IntoResponse for AppError {
    fn into_response(self) -> Response {
        eprintln!("route fail! {:?}", self.0);
        http::StatusCode::INTERNAL_SERVER_ERROR.into_response()
    }
}

// pub type AppResult<T> = std::result::Result<T, AppError>;
pub type AppResult2<T, E> = std::result::Result<std::result::Result<T, E>, AppError>;
