use bytes::{Bytes, BytesMut, BufMut};

pub struct RvtPacket(pub Vec<Bytes>);

impl RvtPacket {
    pub fn encode(self) -> anyhow::Result<Bytes> {
        let mut out = BytesMut::new();

        for f in self.0 {
            let len = f.len().try_into()?;
            out.put_u32_le(len);
            out.put(f);
        }

        Ok(out.freeze())
    }
}